package golfCourse.agents.contactToOTASystemAgent;

import golfCourse.agents.contactToOTASystemAgent.handlers.CloseSystemHandler;
import golfCourse.agents.contactToOTASystemAgent.handlers.GolfCourseAvailHandler;
import golfCourse.communication.ontology.CA_send_OTAGolfCourseAvailRQ;
import golfCourse.communication.ontology.Close_system_action;
import golfCourse.communication.services.ActionDispatcher;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.NotUnderstoodException;
import jade.domain.FIPAAgentManagement.RefuseException;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.proto.AchieveREResponder;
import jade.proto.states.HandlerSelector;

public class ContactToOTASystemAgentResponder extends AchieveREResponder {
	
	public final String ACT_KEY = "__action" + hashCode();

	public ContactToOTASystemAgentResponder(Agent a, MessageTemplate mt) {
		super(a, mt);

		HandlerSelector selector = new ActionDispatcher(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY);
		
		/* 
		 * this behaviour is only for system test
		 * agent receive 
		 */
		selector.registerHandler(CA_send_OTAGolfCourseAvailRQ.class.getName(),
				new GolfCourseAvailHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));
		
		selector.registerHandler(Close_system_action.class.getName(),
				new CloseSystemHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		registerPrepareResultNotification(selector);
	}
	
    protected ACLMessage prepareResponse(ACLMessage request) throws NotUnderstoodException, RefuseException {
    	// Don't say AGREE or REFUSE exlipictly; no response means AGREE
        return null;
    }

}
