package golfCourse.agents.databaseAgent;

import golfCourse.agents.databaseAgent.handlers.ClearDatabaseHandler;
import golfCourse.agents.databaseAgent.handlers.CloseSystemHandler;
import golfCourse.agents.databaseAgent.handlers.LoadDataHandler;
import golfCourse.communication.ontology.Close_system_action;
import golfCourse.communication.ontology.DBA_clear_database;
import golfCourse.communication.ontology.DBA_save_golf_courses;
import golfCourse.communication.services.ActionDispatcher;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.NotUnderstoodException;
import jade.domain.FIPAAgentManagement.RefuseException;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.proto.AchieveREResponder;
import jade.proto.states.HandlerSelector;

public class DataBaseAgentResponder extends AchieveREResponder {

	public final String ACT_KEY = "__action" + hashCode();

	public DataBaseAgentResponder(Agent a, MessageTemplate mt) {
		super(a, mt);

		HandlerSelector selector = new ActionDispatcher(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY);
		
		// load data
		selector.registerHandler(DBA_save_golf_courses.class.getName(),
				new LoadDataHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY)
		);
		
		// clear database - remove all data
		selector.registerHandler(DBA_clear_database.class.getName(),
				new ClearDatabaseHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		// close system action
		selector.registerHandler(Close_system_action.class.getName(),
				new CloseSystemHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		
		registerPrepareResultNotification(selector);
	}
	
    protected ACLMessage prepareResponse(ACLMessage request) throws NotUnderstoodException, RefuseException {
    	// Don't say AGREE or REFUSE exlipictly; no response means AGREE
        return null;
    }
}
