package golfCourse.agents.managerAgent.system.handlers;

import golfCourse.agents.managerAgent.ManagerAgent;
import golfCourse.agents.managerAgent.behaviours.CustomerResponseBehaviour;
import golfCourse.agents.searchAgent.handlers.FindGolfCoursesHandler;
import golfCourse.communication.ontology.MA_send_OTAGolfCourseSearchRS;
import golfCourse.communication.services.RequestHandler;
import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.core.behaviours.DataStore;
import jade.domain.FIPAAgentManagement.FailureException;
import jade.lang.acl.ACLMessage;
import jade.util.Logger;

public class CustomerResponseHandler extends RequestHandler {

	private static Logger logger = Logger.getMyLogger(CustomerResponseHandler.class.getName());
	
	protected ManagerAgent myAgent;
	
	public CustomerResponseHandler(Agent a, DataStore ds, Object requestKey,
			Object actKey, Object notificationKey) {
		super(a, ds, requestKey, actKey, notificationKey);
		myAgent = (ManagerAgent) a;
	}

	protected final ACLMessage prepareResponse(ACLMessage request, Action act) throws FailureException {
		
		logger.info(myAgent.getLocalName() + " - customer response action");
		
		MA_send_OTAGolfCourseSearchRS action = (MA_send_OTAGolfCourseSearchRS)act.getAction();
		
		myAgent.addBehaviour(new CustomerResponseBehaviour(action.getMessage_OTAGolfCourseSearchRS().getOtaMessage(),
				action.getCustomerMessageID(), myAgent));

		return null;
	}
}
