package golfCourse.agents.managerAgent.system.handlers;

import golfCourse.agents.managerAgent.ManagerAgent;
import golfCourse.agents.managerAgent.behaviours.CustomerResponseBehaviour;
import golfCourse.communication.ontology.MA_generate_OTA_error_message;
import golfCourse.communication.services.RequestHandler;
import golfCourse.exceptions.TranslateException;
import golfCourse.translations.toOTA.GolfCourseSearchRSErrorTranslator;
import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.core.behaviours.DataStore;
import jade.domain.FIPAAgentManagement.FailureException;
import jade.lang.acl.ACLMessage;
import jade.util.Logger;

public class GenerateOTAErrorMessageHandler  extends RequestHandler {

	private static Logger logger = Logger.getMyLogger(GenerateOTAErrorMessageHandler.class.getName());
	
	protected ManagerAgent myAgent;
	private String answer = null;
	private String customerAID = "";
	
	public GenerateOTAErrorMessageHandler(Agent a, DataStore ds, Object requestKey,
			Object actKey, Object notificationKey) {
		super(a, ds, requestKey, actKey, notificationKey);
		myAgent = (ManagerAgent) a;
	}

	protected final ACLMessage prepareResponse(ACLMessage request, Action act) throws FailureException {
		
		MA_generate_OTA_error_message action = (MA_generate_OTA_error_message)act.getAction();
		
		String errorMessage = action.getError_msg().getMessage();
		String customerID = action.getCustomerMessageID();
		
		try {
		String otaMessage = GolfCourseSearchRSErrorTranslator.generateError(errorMessage);
		myAgent.addBehaviour(new CustomerResponseBehaviour(otaMessage, customerID, myAgent));
		}
		catch(TranslateException e)
		{
			logger.info(myAgent.getLocalName() + " cannot generate ota message with info about errors - " + e.getMessage());
			// TODO
		}
		return null;
	}
}
