package golfCourse.agents.translationAgent;

import golfCourse.agents.translationAgent.handlers.CloseSystemHandler;
import golfCourse.agents.translationAgent.handlers.TranslateFromOTAAvailRSHandler;
import golfCourse.agents.translationAgent.handlers.TranslateFromOTASearchRQHandler;
import golfCourse.agents.translationAgent.handlers.TranslateFromOTASearchRSHandler;
import golfCourse.agents.translationAgent.handlers.TranslateToOTAGolfCourseAvailRQHandler;
import golfCourse.agents.translationAgent.handlers.TranslateToOTASearchRSHandler;
import golfCourse.communication.ontology.Close_system_action;
import golfCourse.communication.ontology.TA_translate_from_OTAGolfCourseAvailRS;
import golfCourse.communication.ontology.TA_translate_from_OTAGolfCourseSearchRQ;
import golfCourse.communication.ontology.TA_translate_from_OTAGolfCourseSearchRS;
import golfCourse.communication.ontology.TA_translate_to_OTAGolfCourseAvailRQ;
import golfCourse.communication.ontology.TA_translate_to_OTAGolfCourseSearchRS;
import golfCourse.communication.services.ActionDispatcher;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.NotUnderstoodException;
import jade.domain.FIPAAgentManagement.RefuseException;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.proto.AchieveREResponder;
import jade.proto.states.HandlerSelector;

public class TranslationAgentResponder extends AchieveREResponder {

	public final String ACT_KEY = "__action" + hashCode();
	
	public TranslationAgentResponder(Agent a, MessageTemplate mt) {
		super(a, mt);

		HandlerSelector selector = new ActionDispatcher(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY);
		
		selector.registerHandler(TA_translate_from_OTAGolfCourseSearchRQ.class.getName(),
				new TranslateFromOTASearchRQHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY)
		);
		
		selector.registerHandler(TA_translate_from_OTAGolfCourseSearchRS.class.getName(),
				new TranslateFromOTASearchRSHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		selector.registerHandler(TA_translate_to_OTAGolfCourseSearchRS.class.getName(),
				new TranslateToOTASearchRSHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		selector.registerHandler(Close_system_action.class.getName(),
				new CloseSystemHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		selector.registerHandler(TA_translate_to_OTAGolfCourseAvailRQ.class.getName(),
				new TranslateToOTAGolfCourseAvailRQHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		selector.registerHandler(TA_translate_from_OTAGolfCourseAvailRS.class.getName(),
				new TranslateFromOTAAvailRSHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		registerPrepareResultNotification(selector);
	}
	
    protected ACLMessage prepareResponse(ACLMessage request) throws NotUnderstoodException, RefuseException {
    	// Don't say AGREE or REFUSE exlipictly; no response means AGREE
        return null;
    }
}
