package golfCourse.agents.translationAgent.handlers;

import golfCourse.agents.translationAgent.TranslationAgent;
import golfCourse.communication.services.RequestHandler;
import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.core.behaviours.DataStore;
import jade.domain.FIPAAgentManagement.FailureException;
import jade.lang.acl.ACLMessage;
import jade.util.Logger;

public class CloseSystemHandler extends RequestHandler {
	
	private static Logger logger = Logger.getMyLogger(CloseSystemHandler.class.getName());
	private TranslationAgent myAgent;
	
	public CloseSystemHandler(Agent a, DataStore ds, Object requestKey,
			Object actKey, Object notificationKey) {
		super(a, ds, requestKey, actKey, notificationKey);
		
		myAgent = (TranslationAgent)a;
	}

	protected final ACLMessage prepareResponse(ACLMessage request, Action act) throws FailureException {
		logger.info(myAgent.getLocalName() + " received message about closing system");
		logger.info(myAgent.getLocalName() + " is closing...");
		myAgent.doDelete();
		// no response
		return null;
	}
}
