

package golfCourse.ontologies.jastor.contacts;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;


/**
 * Implementation of {@link golfCourse.ontologies.jastor.contacts.Contacts}
 * Use the golfCourse.ontologies.jastor.contacts.ContactsFactory to create instances of this class.
 * <p>(URI: file:///D:/ontologies/domain/Contacts/Contacts#Contacts)</p>
 * <br>
 */
public class ContactsImpl extends com.ibm.adtech.jastor.ThingImpl implements golfCourse.ontologies.jastor.contacts.Contacts {
	

	private static com.hp.hpl.jena.rdf.model.Property useProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#use");
	private golfCourse.ontologies.jastor.contacts.UseType use;
	private static com.hp.hpl.jena.rdf.model.Property locationProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#location");
	private golfCourse.ontologies.jastor.contacts.LocationType location;
	private static com.hp.hpl.jena.rdf.model.Property technologyProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#technology");
	private golfCourse.ontologies.jastor.contacts.ContactTechnology technology;
	private static com.hp.hpl.jena.rdf.model.Property serviceTypeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#serviceType");
	private golfCourse.ontologies.jastor.contacts.ContactSrvcCode serviceType;
	private static com.hp.hpl.jena.rdf.model.Property addressProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#address");
	private java.lang.String address;

	ContactsImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static ContactsImpl getContacts(Resource resource, Model model) throws JastorException {
		if (!resource.hasProperty(RDF.type,Contacts.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + Contacts.TYPE);
		return new ContactsImpl(resource, model);
	}
	    
	static ContactsImpl createContacts(Resource resource, Model model) throws JastorException {
		ContactsImpl impl = new ContactsImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, Contacts.TYPE)))
			impl._model.add(impl._resource, RDF.type, Contacts.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	golfCourse.ontologies.jastor.contacts.ContactsFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _resource.listProperties(useProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(locationProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(technologyProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(serviceTypeProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(addressProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, golfCourse.ontologies.jastor.contacts.Contacts.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
		use = null;
		location = null;
		technology = null;
		serviceType = null;
		address = null;
	}


	public golfCourse.ontologies.jastor.contacts.UseType getUse() throws JastorException {
		if (use != null)
			return use;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, useProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
			throw new JastorInvalidRDFNodeException(uri() + ": use getProperty() in golfCourse.ontologies.jastor.contacts.Contacts model not Resource", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
		use = golfCourse.ontologies.jastor.contacts.ContactsFactory.getUseType(resource,_model);
		return use;
	}

	public void setUse(golfCourse.ontologies.jastor.contacts.UseType use) throws JastorException {
		if (_resource.hasProperty(useProperty)) {
			_resource.removeAll(useProperty);
		}
		this.use = use;
		if (use != null) {
			_resource.addProperty(useProperty, use.resource());
		}			
	}
		
	public golfCourse.ontologies.jastor.contacts.UseType setUse() throws JastorException {
		if (_resource.hasProperty(useProperty)) {
			_resource.removeAll(useProperty);
		}
		golfCourse.ontologies.jastor.contacts.UseType use = golfCourse.ontologies.jastor.contacts.ContactsFactory.createUseType(_model.createResource(),_model);
		this.use = use;
		_resource.addProperty(useProperty, use.resource());
		return use;
	}
	
	public golfCourse.ontologies.jastor.contacts.UseType setUse(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		if (!resource.hasProperty(RDF.type,golfCourse.ontologies.jastor.contacts.UseType.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + golfCourse.ontologies.jastor.contacts.UseType.TYPE);
		if (_resource.hasProperty(useProperty)) {
			_resource.removeAll(useProperty);
		}
		golfCourse.ontologies.jastor.contacts.UseType use = golfCourse.ontologies.jastor.contacts.ContactsFactory.getUseType(resource,_model);
		this.use = use;
		_resource.addProperty(useProperty, use.resource());
		return use;
	}
	

	public golfCourse.ontologies.jastor.contacts.LocationType getLocation() throws JastorException {
		if (location != null)
			return location;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, locationProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
			throw new JastorInvalidRDFNodeException(uri() + ": location getProperty() in golfCourse.ontologies.jastor.contacts.Contacts model not Resource", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
		location = golfCourse.ontologies.jastor.contacts.ContactsFactory.getLocationType(resource,_model);
		return location;
	}

	public void setLocation(golfCourse.ontologies.jastor.contacts.LocationType location) throws JastorException {
		if (_resource.hasProperty(locationProperty)) {
			_resource.removeAll(locationProperty);
		}
		this.location = location;
		if (location != null) {
			_resource.addProperty(locationProperty, location.resource());
		}			
	}
		
	public golfCourse.ontologies.jastor.contacts.LocationType setLocation() throws JastorException {
		if (_resource.hasProperty(locationProperty)) {
			_resource.removeAll(locationProperty);
		}
		golfCourse.ontologies.jastor.contacts.LocationType location = golfCourse.ontologies.jastor.contacts.ContactsFactory.createLocationType(_model.createResource(),_model);
		this.location = location;
		_resource.addProperty(locationProperty, location.resource());
		return location;
	}
	
	public golfCourse.ontologies.jastor.contacts.LocationType setLocation(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		if (!resource.hasProperty(RDF.type,golfCourse.ontologies.jastor.contacts.LocationType.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + golfCourse.ontologies.jastor.contacts.LocationType.TYPE);
		if (_resource.hasProperty(locationProperty)) {
			_resource.removeAll(locationProperty);
		}
		golfCourse.ontologies.jastor.contacts.LocationType location = golfCourse.ontologies.jastor.contacts.ContactsFactory.getLocationType(resource,_model);
		this.location = location;
		_resource.addProperty(locationProperty, location.resource());
		return location;
	}
	

	public golfCourse.ontologies.jastor.contacts.ContactTechnology getTechnology() throws JastorException {
		if (technology != null)
			return technology;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, technologyProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
			throw new JastorInvalidRDFNodeException(uri() + ": technology getProperty() in golfCourse.ontologies.jastor.contacts.Contacts model not Resource", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
		technology = golfCourse.ontologies.jastor.contacts.ContactsFactory.getContactTechnology(resource,_model);
		return technology;
	}

	public void setTechnology(golfCourse.ontologies.jastor.contacts.ContactTechnology technology) throws JastorException {
		if (_resource.hasProperty(technologyProperty)) {
			_resource.removeAll(technologyProperty);
		}
		this.technology = technology;
		if (technology != null) {
			_resource.addProperty(technologyProperty, technology.resource());
		}			
	}
		
	public golfCourse.ontologies.jastor.contacts.ContactTechnology setTechnology() throws JastorException {
		if (_resource.hasProperty(technologyProperty)) {
			_resource.removeAll(technologyProperty);
		}
		golfCourse.ontologies.jastor.contacts.ContactTechnology technology = golfCourse.ontologies.jastor.contacts.ContactsFactory.createContactTechnology(_model.createResource(),_model);
		this.technology = technology;
		_resource.addProperty(technologyProperty, technology.resource());
		return technology;
	}
	
	public golfCourse.ontologies.jastor.contacts.ContactTechnology setTechnology(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		if (!resource.hasProperty(RDF.type,golfCourse.ontologies.jastor.contacts.ContactTechnology.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + golfCourse.ontologies.jastor.contacts.ContactTechnology.TYPE);
		if (_resource.hasProperty(technologyProperty)) {
			_resource.removeAll(technologyProperty);
		}
		golfCourse.ontologies.jastor.contacts.ContactTechnology technology = golfCourse.ontologies.jastor.contacts.ContactsFactory.getContactTechnology(resource,_model);
		this.technology = technology;
		_resource.addProperty(technologyProperty, technology.resource());
		return technology;
	}
	

	public golfCourse.ontologies.jastor.contacts.ContactSrvcCode getServiceType() throws JastorException {
		if (serviceType != null)
			return serviceType;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, serviceTypeProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
			throw new JastorInvalidRDFNodeException(uri() + ": serviceType getProperty() in golfCourse.ontologies.jastor.contacts.Contacts model not Resource", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
		serviceType = golfCourse.ontologies.jastor.contacts.ContactsFactory.getContactSrvcCode(resource,_model);
		return serviceType;
	}

	public void setServiceType(golfCourse.ontologies.jastor.contacts.ContactSrvcCode serviceType) throws JastorException {
		if (_resource.hasProperty(serviceTypeProperty)) {
			_resource.removeAll(serviceTypeProperty);
		}
		this.serviceType = serviceType;
		if (serviceType != null) {
			_resource.addProperty(serviceTypeProperty, serviceType.resource());
		}			
	}
		
	public golfCourse.ontologies.jastor.contacts.ContactSrvcCode setServiceType() throws JastorException {
		if (_resource.hasProperty(serviceTypeProperty)) {
			_resource.removeAll(serviceTypeProperty);
		}
		golfCourse.ontologies.jastor.contacts.ContactSrvcCode serviceType = golfCourse.ontologies.jastor.contacts.ContactsFactory.createContactSrvcCode(_model.createResource(),_model);
		this.serviceType = serviceType;
		_resource.addProperty(serviceTypeProperty, serviceType.resource());
		return serviceType;
	}
	
	public golfCourse.ontologies.jastor.contacts.ContactSrvcCode setServiceType(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		if (!resource.hasProperty(RDF.type,golfCourse.ontologies.jastor.contacts.ContactSrvcCode.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + golfCourse.ontologies.jastor.contacts.ContactSrvcCode.TYPE);
		if (_resource.hasProperty(serviceTypeProperty)) {
			_resource.removeAll(serviceTypeProperty);
		}
		golfCourse.ontologies.jastor.contacts.ContactSrvcCode serviceType = golfCourse.ontologies.jastor.contacts.ContactsFactory.getContactSrvcCode(resource,_model);
		this.serviceType = serviceType;
		_resource.addProperty(serviceTypeProperty, serviceType.resource());
		return serviceType;
	}
	
	public java.lang.String getAddress() throws JastorException {
		if (address != null)
			return address;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, addressProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": address getProperty() in golfCourse.ontologies.jastor.contacts.Contacts model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal address in Contacts is not of type java.lang.String", literal);
		address = (java.lang.String)obj;
		return address;
	}
	
	public void setAddress(java.lang.String address) throws JastorException {
		if (_resource.hasProperty(addressProperty)) {
			_resource.removeAll(addressProperty);
		}
		this.address = address;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (address != null) {
			_resource.addProperty(addressProperty, _model.createTypedLiteral(address));
		}	
	}
 


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof ContactsListener))
			throw new IllegalArgumentException("ThingListener must be instance of ContactsListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((ContactsListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof ContactsListener))
			throw new IllegalArgumentException("ThingListener must be instance of ContactsListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	// private class ThingModelChangedListener extends StatementListener {
	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(useProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				use = null;
				if (true) { // don't check resource type if the property range is Resource
					try {
						use = golfCourse.ontologies.jastor.contacts.ContactsFactory.getUseType(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
				}
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.useChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(locationProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				location = null;
				if (true) { // don't check resource type if the property range is Resource
					try {
						location = golfCourse.ontologies.jastor.contacts.ContactsFactory.getLocationType(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
				}
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.locationChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(technologyProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				technology = null;
				if (true) { // don't check resource type if the property range is Resource
					try {
						technology = golfCourse.ontologies.jastor.contacts.ContactsFactory.getContactTechnology(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
				}
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.technologyChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(serviceTypeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				serviceType = null;
				if (true) { // don't check resource type if the property range is Resource
					try {
						serviceType = golfCourse.ontologies.jastor.contacts.ContactsFactory.getContactSrvcCode(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
				}
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.serviceTypeChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(addressProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					address = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.addressChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(useProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
					if (use != null && use.resource().equals(resource))
						use = null;				
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.useChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(locationProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
					if (location != null && location.resource().equals(resource))
						location = null;				
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.locationChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(technologyProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
					if (technology != null && technology.resource().equals(resource))
						technology = null;				
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.technologyChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(serviceTypeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
					if (serviceType != null && serviceType.resource().equals(resource))
						serviceType = null;				
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.serviceTypeChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(addressProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (address != null && address.equals(obj))
						address = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ContactsListener listener=(ContactsListener)iter.next();
						listener.addressChanged(golfCourse.ontologies.jastor.contacts.ContactsImpl.this);
					}
				}
				return;
			}
		}

	//}
	


}