

package golfCourse.ontologies.jastor.fee;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;


/**
 * Implementation of {@link golfCourse.ontologies.jastor.fee.Fee}
 * Use the golfCourse.ontologies.jastor.fee.FeeFactory to create instances of this class.
 * <p>(URI: file:///D:/ontologies/domain/Golf/Fee#Fee)</p>
 * <br>
 */
public class FeeImpl extends com.ibm.adtech.jastor.ThingImpl implements golfCourse.ontologies.jastor.fee.Fee {
	

	private static com.hp.hpl.jena.rdf.model.Property effectiveDateProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Fee#effectiveDate");
	private java.lang.String effectiveDate;
	private static com.hp.hpl.jena.rdf.model.Property expireDateProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Fee#expireDate");
	private java.lang.String expireDate;
	private static com.hp.hpl.jena.rdf.model.Property priceProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Fee#price");
	private com.ibm.adtech.jastor.Thing price;
	private static com.hp.hpl.jena.rdf.model.Property descriptionProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Fee#description");
	private java.util.ArrayList description;

	FeeImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static FeeImpl getFee(Resource resource, Model model) throws JastorException {
		if (!resource.hasProperty(RDF.type,Fee.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + Fee.TYPE);
		return new FeeImpl(resource, model);
	}
	    
	static FeeImpl createFee(Resource resource, Model model) throws JastorException {
		FeeImpl impl = new FeeImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, Fee.TYPE)))
			impl._model.add(impl._resource, RDF.type, Fee.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	golfCourse.ontologies.jastor.fee.FeeFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _resource.listProperties(effectiveDateProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(expireDateProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(priceProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(descriptionProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, golfCourse.ontologies.jastor.fee.Fee.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
		effectiveDate = null;
		expireDate = null;
		price = null;
		description = null;
	}

	public java.lang.String getEffectiveDate() throws JastorException {
		if (effectiveDate != null)
			return effectiveDate;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, effectiveDateProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": effectiveDate getProperty() in golfCourse.ontologies.jastor.fee.Fee model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal effectiveDate in Fee is not of type java.lang.String", literal);
		effectiveDate = (java.lang.String)obj;
		return effectiveDate;
	}
	
	public void setEffectiveDate(java.lang.String effectiveDate) throws JastorException {
		if (_resource.hasProperty(effectiveDateProperty)) {
			_resource.removeAll(effectiveDateProperty);
		}
		this.effectiveDate = effectiveDate;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (effectiveDate != null) {
			_resource.addProperty(effectiveDateProperty, _model.createTypedLiteral(effectiveDate));
		}	
	}

	public java.lang.String getExpireDate() throws JastorException {
		if (expireDate != null)
			return expireDate;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, expireDateProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": expireDate getProperty() in golfCourse.ontologies.jastor.fee.Fee model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal expireDate in Fee is not of type java.lang.String", literal);
		expireDate = (java.lang.String)obj;
		return expireDate;
	}
	
	public void setExpireDate(java.lang.String expireDate) throws JastorException {
		if (_resource.hasProperty(expireDateProperty)) {
			_resource.removeAll(expireDateProperty);
		}
		this.expireDate = expireDate;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (expireDate != null) {
			_resource.addProperty(expireDateProperty, _model.createTypedLiteral(expireDate));
		}	
	}


	public com.ibm.adtech.jastor.Thing getPrice() throws JastorException {
		if (price != null)
			return price;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, priceProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
			throw new JastorInvalidRDFNodeException(uri() + ": price getProperty() in golfCourse.ontologies.jastor.fee.Fee model not Resource", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
		price = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		return price;
	}

	public void setPrice(com.ibm.adtech.jastor.Thing price) throws JastorException {
		if (_resource.hasProperty(priceProperty)) {
			_resource.removeAll(priceProperty);
		}
		this.price = price;
		if (price != null) {
			_resource.addProperty(priceProperty, price.resource());
		}			
	}
		
	public com.ibm.adtech.jastor.Thing setPrice() throws JastorException {
		if (_resource.hasProperty(priceProperty)) {
			_resource.removeAll(priceProperty);
		}
		com.ibm.adtech.jastor.Thing price = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		this.price = price;
		_resource.addProperty(priceProperty, price.resource());
		return price;
	}
	
	public com.ibm.adtech.jastor.Thing setPrice(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		if (_resource.hasProperty(priceProperty)) {
			_resource.removeAll(priceProperty);
		}
		com.ibm.adtech.jastor.Thing price = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		this.price = price;
		_resource.addProperty(priceProperty, price.resource());
		return price;
	}
	

	private void initDescription() throws JastorException {
		this.description = new java.util.ArrayList();
		StmtIterator it = _model.listStatements(_resource, descriptionProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the file:///D:/ontologies/domain/Golf/Fee#description properties in Fee model not a Resource", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
			if (true) { // don't check resource type if the property range is Resource
				com.ibm.adtech.jastor.Thing description = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
				this.description.add(description);
			}
		}
	}

	public java.util.Iterator getDescription() throws JastorException {
		if (description == null)
			initDescription();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(description,_resource,descriptionProperty,true);
	}

	public void addDescription(com.ibm.adtech.jastor.Thing description) throws JastorException {
		if (this.description == null)
			initDescription();
		if (this.description.contains(description)) {
			this.description.remove(description);
			this.description.add(description);
			return;
		}
		this.description.add(description);
		_resource.addProperty(descriptionProperty,description.resource());
	}
	
	public com.ibm.adtech.jastor.Thing addDescription() throws JastorException {
		com.ibm.adtech.jastor.Thing description = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		if (this.description == null)
			initDescription();
		this.description.add(description);
		_resource.addProperty(descriptionProperty,description.resource());
		return description;
	}
	
	public com.ibm.adtech.jastor.Thing addDescription(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		com.ibm.adtech.jastor.Thing description = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		if (this.description == null)
			initDescription();
		if (this.description.contains(description))
			return description;
		this.description.add(description);
		_resource.addProperty(descriptionProperty,description.resource());
		return description;
	}
	
	public void removeDescription(com.ibm.adtech.jastor.Thing description) throws JastorException {
		if (this.description == null)
			initDescription();
		if (!this.description.contains(description))
			return;
		if (!_model.contains(_resource, descriptionProperty, description.resource()))
			return;
		this.description.remove(description);
		_model.remove(_model.listStatements(_resource, descriptionProperty, description.resource()));
	}
		  


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof FeeListener))
			throw new IllegalArgumentException("ThingListener must be instance of FeeListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((FeeListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof FeeListener))
			throw new IllegalArgumentException("ThingListener must be instance of FeeListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	// private class ThingModelChangedListener extends StatementListener {
	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(effectiveDateProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					effectiveDate = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						FeeListener listener=(FeeListener)iter.next();
						listener.effectiveDateChanged(golfCourse.ontologies.jastor.fee.FeeImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(expireDateProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					expireDate = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						FeeListener listener=(FeeListener)iter.next();
						listener.expireDateChanged(golfCourse.ontologies.jastor.fee.FeeImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(priceProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				price = null;
				if (true) { // don't check resource type if the property range is Resource
					try {
						price = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
				}
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						FeeListener listener=(FeeListener)iter.next();
						listener.priceChanged(golfCourse.ontologies.jastor.fee.FeeImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(descriptionProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _description = null;
					try {
						_description = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
					if (description == null) {
						try {
							initDescription();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!description.contains(_description))
						description.add(_description);
					if (listeners != null) {
						java.util.ArrayList consumersForDescription;
						synchronized (listeners) {
							consumersForDescription = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForDescription.iterator();iter.hasNext();){
							FeeListener listener=(FeeListener)iter.next();
							listener.descriptionAdded(golfCourse.ontologies.jastor.fee.FeeImpl.this,_description);
						}
					}
				}
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(effectiveDateProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (effectiveDate != null && effectiveDate.equals(obj))
						effectiveDate = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						FeeListener listener=(FeeListener)iter.next();
						listener.effectiveDateChanged(golfCourse.ontologies.jastor.fee.FeeImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(expireDateProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (expireDate != null && expireDate.equals(obj))
						expireDate = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						FeeListener listener=(FeeListener)iter.next();
						listener.expireDateChanged(golfCourse.ontologies.jastor.fee.FeeImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(priceProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
					if (price != null && price.resource().equals(resource))
						price = null;				
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						FeeListener listener=(FeeListener)iter.next();
						listener.priceChanged(golfCourse.ontologies.jastor.fee.FeeImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(descriptionProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _description = null;
					if (description != null) {
						boolean found = false;
						for (int i=0;i<description.size();i++) {
							com.ibm.adtech.jastor.Thing __item = (com.ibm.adtech.jastor.Thing) description.get(i);
							if (__item.resource().equals(resource)) {
								found = true;
								_description = __item;
								break;
							}
						}
						if (found)
							description.remove(_description);
						else {
							try {
								_description = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
							} catch (JastorException e) {
							}
						}
					} else {
						try {
							_description = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
						} catch (JastorException e) {
						}
					}
					if (listeners != null) {
						java.util.ArrayList consumersForDescription;
						synchronized (listeners) {
							consumersForDescription = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForDescription.iterator();iter.hasNext();){
							FeeListener listener=(FeeListener)iter.next();
							listener.descriptionRemoved(golfCourse.ontologies.jastor.fee.FeeImpl.this,_description);
						}
					}
				}
				return;
			}
		}

	//}
	


}