

package golfCourse.ontologies.jastor.location;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;


/**
 * Implementation of {@link golfCourse.ontologies.jastor.location.AddressRecord}
 * Use the golfCourse.ontologies.jastor.location.AddressRecordFactory to create instances of this class.
 * <p>(URI: file:///D:/ontologies/domain/Location/AddressRecord#AddressRecord)</p>
 * <br>
 */
public class AddressRecordImpl extends com.ibm.adtech.jastor.ThingImpl implements golfCourse.ontologies.jastor.location.AddressRecord {
	

	private static com.hp.hpl.jena.rdf.model.Property zipProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/AddressRecord#zip");
	private java.lang.String zip;
	private static com.hp.hpl.jena.rdf.model.Property fullAddressProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/AddressRecord#fullAddress");
	private java.lang.String fullAddress;
	private static com.hp.hpl.jena.rdf.model.Property regionProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/AddressRecord#region");
	private java.lang.String region;
	private static com.hp.hpl.jena.rdf.model.Property flatNumberProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/AddressRecord#flatNumber");
	private java.lang.String flatNumber;
	private static com.hp.hpl.jena.rdf.model.Property countryProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/AddressRecord#country");
	private java.lang.String country;
	private static com.hp.hpl.jena.rdf.model.Property houseNumberProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/AddressRecord#houseNumber");
	private java.lang.String houseNumber;
	private static com.hp.hpl.jena.rdf.model.Property streetProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/AddressRecord#street");
	private java.lang.String street;
	private static com.hp.hpl.jena.rdf.model.Property cityProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/AddressRecord#city");
	private java.lang.String city;

	AddressRecordImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static AddressRecordImpl getAddressRecord(Resource resource, Model model) throws JastorException {
		if (!resource.hasProperty(RDF.type,AddressRecord.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + AddressRecord.TYPE);
		return new AddressRecordImpl(resource, model);
	}
	    
	static AddressRecordImpl createAddressRecord(Resource resource, Model model) throws JastorException {
		AddressRecordImpl impl = new AddressRecordImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, AddressRecord.TYPE)))
			impl._model.add(impl._resource, RDF.type, AddressRecord.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	golfCourse.ontologies.jastor.location.AddressRecordFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _resource.listProperties(zipProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(fullAddressProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(regionProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(flatNumberProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(countryProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(houseNumberProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(streetProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(cityProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, golfCourse.ontologies.jastor.location.AddressRecord.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
		zip = null;
		fullAddress = null;
		region = null;
		flatNumber = null;
		country = null;
		houseNumber = null;
		street = null;
		city = null;
	}

	public java.lang.String getZip() throws JastorException {
		if (zip != null)
			return zip;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, zipProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": zip getProperty() in golfCourse.ontologies.jastor.location.AddressRecord model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal zip in AddressRecord is not of type java.lang.String", literal);
		zip = (java.lang.String)obj;
		return zip;
	}
	
	public void setZip(java.lang.String zip) throws JastorException {
		if (_resource.hasProperty(zipProperty)) {
			_resource.removeAll(zipProperty);
		}
		this.zip = zip;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (zip != null) {
			_resource.addProperty(zipProperty, _model.createTypedLiteral(zip));
		}	
	}

	public java.lang.String getFullAddress() throws JastorException {
		if (fullAddress != null)
			return fullAddress;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, fullAddressProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": fullAddress getProperty() in golfCourse.ontologies.jastor.location.AddressRecord model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal fullAddress in AddressRecord is not of type java.lang.String", literal);
		fullAddress = (java.lang.String)obj;
		return fullAddress;
	}
	
	public void setFullAddress(java.lang.String fullAddress) throws JastorException {
		if (_resource.hasProperty(fullAddressProperty)) {
			_resource.removeAll(fullAddressProperty);
		}
		this.fullAddress = fullAddress;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (fullAddress != null) {
			_resource.addProperty(fullAddressProperty, _model.createTypedLiteral(fullAddress));
		}	
	}

	public java.lang.String getRegion() throws JastorException {
		if (region != null)
			return region;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, regionProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": region getProperty() in golfCourse.ontologies.jastor.location.AddressRecord model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal region in AddressRecord is not of type java.lang.String", literal);
		region = (java.lang.String)obj;
		return region;
	}
	
	public void setRegion(java.lang.String region) throws JastorException {
		if (_resource.hasProperty(regionProperty)) {
			_resource.removeAll(regionProperty);
		}
		this.region = region;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (region != null) {
			_resource.addProperty(regionProperty, _model.createTypedLiteral(region));
		}	
	}

	public java.lang.String getFlatNumber() throws JastorException {
		if (flatNumber != null)
			return flatNumber;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, flatNumberProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": flatNumber getProperty() in golfCourse.ontologies.jastor.location.AddressRecord model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal flatNumber in AddressRecord is not of type java.lang.String", literal);
		flatNumber = (java.lang.String)obj;
		return flatNumber;
	}
	
	public void setFlatNumber(java.lang.String flatNumber) throws JastorException {
		if (_resource.hasProperty(flatNumberProperty)) {
			_resource.removeAll(flatNumberProperty);
		}
		this.flatNumber = flatNumber;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (flatNumber != null) {
			_resource.addProperty(flatNumberProperty, _model.createTypedLiteral(flatNumber));
		}	
	}

	public java.lang.String getCountry() throws JastorException {
		if (country != null)
			return country;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, countryProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": country getProperty() in golfCourse.ontologies.jastor.location.AddressRecord model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal country in AddressRecord is not of type java.lang.String", literal);
		country = (java.lang.String)obj;
		return country;
	}
	
	public void setCountry(java.lang.String country) throws JastorException {
		if (_resource.hasProperty(countryProperty)) {
			_resource.removeAll(countryProperty);
		}
		this.country = country;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (country != null) {
			_resource.addProperty(countryProperty, _model.createTypedLiteral(country));
		}	
	}

	public java.lang.String getHouseNumber() throws JastorException {
		if (houseNumber != null)
			return houseNumber;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, houseNumberProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": houseNumber getProperty() in golfCourse.ontologies.jastor.location.AddressRecord model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal houseNumber in AddressRecord is not of type java.lang.String", literal);
		houseNumber = (java.lang.String)obj;
		return houseNumber;
	}
	
	public void setHouseNumber(java.lang.String houseNumber) throws JastorException {
		if (_resource.hasProperty(houseNumberProperty)) {
			_resource.removeAll(houseNumberProperty);
		}
		this.houseNumber = houseNumber;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (houseNumber != null) {
			_resource.addProperty(houseNumberProperty, _model.createTypedLiteral(houseNumber));
		}	
	}

	public java.lang.String getStreet() throws JastorException {
		if (street != null)
			return street;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, streetProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": street getProperty() in golfCourse.ontologies.jastor.location.AddressRecord model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal street in AddressRecord is not of type java.lang.String", literal);
		street = (java.lang.String)obj;
		return street;
	}
	
	public void setStreet(java.lang.String street) throws JastorException {
		if (_resource.hasProperty(streetProperty)) {
			_resource.removeAll(streetProperty);
		}
		this.street = street;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (street != null) {
			_resource.addProperty(streetProperty, _model.createTypedLiteral(street));
		}	
	}

	public java.lang.String getCity() throws JastorException {
		if (city != null)
			return city;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, cityProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": city getProperty() in golfCourse.ontologies.jastor.location.AddressRecord model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal city in AddressRecord is not of type java.lang.String", literal);
		city = (java.lang.String)obj;
		return city;
	}
	
	public void setCity(java.lang.String city) throws JastorException {
		if (_resource.hasProperty(cityProperty)) {
			_resource.removeAll(cityProperty);
		}
		this.city = city;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (city != null) {
			_resource.addProperty(cityProperty, _model.createTypedLiteral(city));
		}	
	}
 


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof AddressRecordListener))
			throw new IllegalArgumentException("ThingListener must be instance of AddressRecordListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((AddressRecordListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof AddressRecordListener))
			throw new IllegalArgumentException("ThingListener must be instance of AddressRecordListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	// private class ThingModelChangedListener extends StatementListener {
	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(zipProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					zip = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.zipChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(fullAddressProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					fullAddress = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.fullAddressChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(regionProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					region = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.regionChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(flatNumberProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					flatNumber = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.flatNumberChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(countryProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					country = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.countryChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(houseNumberProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					houseNumber = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.houseNumberChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(streetProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					street = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.streetChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(cityProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					city = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.cityChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(zipProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (zip != null && zip.equals(obj))
						zip = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.zipChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(fullAddressProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (fullAddress != null && fullAddress.equals(obj))
						fullAddress = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.fullAddressChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(regionProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (region != null && region.equals(obj))
						region = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.regionChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(flatNumberProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (flatNumber != null && flatNumber.equals(obj))
						flatNumber = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.flatNumberChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(countryProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (country != null && country.equals(obj))
						country = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.countryChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(houseNumberProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (houseNumber != null && houseNumber.equals(obj))
						houseNumber = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.houseNumberChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(streetProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (street != null && street.equals(obj))
						street = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.streetChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(cityProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (city != null && city.equals(obj))
						city = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						AddressRecordListener listener=(AddressRecordListener)iter.next();
						listener.cityChanged(golfCourse.ontologies.jastor.location.AddressRecordImpl.this);
					}
				}
				return;
			}
		}

	//}
	


}