

package golfCourse.ontologies.jastor.location;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
//import com.ibm.adtech.jastor.JastorException;

/**
 * Interface for OutdoorLocation ontology class<br>
 * Use the golfCourse.ontologies.jastor.location.OutdoorLocationFactory to create instances of this interface.
 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#OutdoorLocation)</p>
 * <br>
 * RDF Schema Standard Properties <br>
 * 	comment : Outdoor location. Geographical and urban references. <br>
 * <br>
 * <br>
 */
public interface OutdoorLocation extends com.ibm.adtech.jastor.Thing {
	
	/**
	 * The rdf:type for this ontology class
     */
	public static final Resource TYPE = ResourceFactory.createResource("file:///D:/ontologies/domain/Location/OutdoorLocation#OutdoorLocation");
	

	/**
	 * The Jena Property for indexPoint 
	 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#indexPoint)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Reference map point. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property indexPointProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#indexPoint");


	/**
	 * The Jena Property for neighbourhood 
	 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#neighbourhood)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	label : Neighbourhood <br>
	 * 	comment : The neighborhood of the  Outdoor location. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property neighbourhoodProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#neighbourhood");


	/**
	 * The Jena Property for address 
	 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#address)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Address details. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property addressProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#address");


	/**
	 * The Jena Property for attractionCategory 
	 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#attractionCategory)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Nearby attractions. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property attractionCategoryProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#attractionCategory");


	/**
	 * The Jena Property for locationCategory 
	 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#locationCategory)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Location category. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property locationCategoryProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#locationCategory");


	/**
	 * The Jena Property for indexPointDist 
	 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#indexPointDist)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Distance from the reference map point. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property indexPointDistProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#indexPointDist");


	/**
	 * The Jena Property for crossStreet 
	 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#crossStreet)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	label : Cross street <br>
	 * 	comment : The nearest street that crosses the street that the restaurant is on. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property crossStreetProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#crossStreet");



}