

package golfCourse.ontologies.jastor.location;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;


/**
 * Implementation of {@link golfCourse.ontologies.jastor.location.OutdoorLocation}
 * Use the golfCourse.ontologies.jastor.location.OutdoorLocationFactory to create instances of this class.
 * <p>(URI: file:///D:/ontologies/domain/Location/OutdoorLocation#OutdoorLocation)</p>
 * <br>
 */
public class OutdoorLocationImpl extends com.ibm.adtech.jastor.ThingImpl implements golfCourse.ontologies.jastor.location.OutdoorLocation {
	

	private static com.hp.hpl.jena.rdf.model.Property indexPointProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#indexPoint");
	private static com.hp.hpl.jena.rdf.model.Property neighbourhoodProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#neighbourhood");
	private static com.hp.hpl.jena.rdf.model.Property addressProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#address");
	private static com.hp.hpl.jena.rdf.model.Property attractionCategoryProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#attractionCategory");
	private static com.hp.hpl.jena.rdf.model.Property locationCategoryProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#locationCategory");
	private static com.hp.hpl.jena.rdf.model.Property indexPointDistProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#indexPointDist");
	private static com.hp.hpl.jena.rdf.model.Property crossStreetProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Location/OutdoorLocation#crossStreet");

	OutdoorLocationImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static OutdoorLocationImpl getOutdoorLocation(Resource resource, Model model) throws JastorException {
		if (!resource.hasProperty(RDF.type,OutdoorLocation.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + OutdoorLocation.TYPE);
		return new OutdoorLocationImpl(resource, model);
	}
	    
	static OutdoorLocationImpl createOutdoorLocation(Resource resource, Model model) throws JastorException {
		OutdoorLocationImpl impl = new OutdoorLocationImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, OutdoorLocation.TYPE)))
			impl._model.add(impl._resource, RDF.type, OutdoorLocation.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	golfCourse.ontologies.jastor.location.OutdoorLocationFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _resource.listProperties(indexPointProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(neighbourhoodProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(addressProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(attractionCategoryProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(locationCategoryProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(indexPointDistProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(crossStreetProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, golfCourse.ontologies.jastor.location.OutdoorLocation.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
	/*	indexPoint = null;
		neighbourhood = null;
		address = null;
		attractionCategory = null;
		locationCategory = null;
		indexPointDist = null;
		crossStreet = null;*/
	}







 


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof OutdoorLocationListener))
			throw new IllegalArgumentException("ThingListener must be instance of OutdoorLocationListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((OutdoorLocationListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof OutdoorLocationListener))
			throw new IllegalArgumentException("ThingListener must be instance of OutdoorLocationListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	// private class ThingModelChangedListener extends StatementListener {
	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(indexPointProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(neighbourhoodProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(addressProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(attractionCategoryProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(locationCategoryProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(indexPointDistProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(crossStreetProperty)) {
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(indexPointProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(neighbourhoodProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(addressProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(attractionCategoryProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(locationCategoryProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(indexPointDistProperty)) {
				return;
			}
			if (stmt.getPredicate().equals(crossStreetProperty)) {
				return;
			}
		}

	//}
	


}