

package golfCourse.ontologies.jastor.price;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
//import com.ibm.adtech.jastor.JastorException;

/**
 * Interface for Price ontology class<br>
 * Use the golfCourse.ontologies.jastor.price.PriceFactory to create instances of this interface.
 * <p>(URI: file:///D:/ontologies/domain/Golf/Price#Price)</p>
 * <br>
 * <br>
 * <br>
 */
public interface Price extends com.ibm.adtech.jastor.Thing {
	
	/**
	 * The rdf:type for this ontology class
     */
	public static final Resource TYPE = ResourceFactory.createResource("file:///D:/ontologies/domain/Golf/Price#Price");
	

	/**
	 * The Jena Property for amount 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Price#amount)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property amountProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#amount");


	/**
	 * The Jena Property for tax 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Price#tax)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property taxProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#tax");


	/**
	 * The Jena Property for currencyCode 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Price#currencyCode)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property currencyCodeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#currencyCode");


	/**
	 * The Jena Property for percent 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Price#percent)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property percentProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#percent");


	/**
	 * The Jena Property for taxInclusive 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Price#taxInclusive)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property taxInclusiveProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#taxInclusive");



	/**
	 * Gets the 'amount' property value
	 * @return		{@link java.lang.Float}
	 * @see			#amountProperty
	 */
	public java.lang.Float getAmount() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'amount' property value
	 * @param		{@link java.lang.Float}
	 * @see			#amountProperty
	 */
	public void setAmount(java.lang.Float amount) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Get an Iterator the 'tax' property values.  This Iteartor
	 * may be used to remove all such values.
	 * @return		{@link java.util.Iterator} of {@link com.ibm.adtech.jastor.Thing}
	 * @see			#taxProperty
	 */
	public java.util.Iterator getTax() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Adds a value for the 'tax' property
	 * @param		The {@link com.ibm.adtech.jastor.Thing} to add
	 * @see			#taxProperty
	 */
	public void addTax(com.ibm.adtech.jastor.Thing tax) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds an anonymous value for the 'tax' property
	 * @return		The anoymous {@link com.ibm.adtech.jastor.Thing} created
	 * @see			#taxProperty
	 */
	public com.ibm.adtech.jastor.Thing addTax() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds a value for the 'tax' property.  This
	 * method is equivalent constructing a new instance of {@link com.ibm.adtech.jastor.Thing} with the factory
	 * and calling addTax(com.ibm.adtech.jastor.Thing tax)
	 * The resource argument have rdf:type http://www.w3.org/2000/01/rdf-schema#Resource.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		The {@link om.hp.hpl.jena.rdf.model.Resource} to add
	 * @see			#taxProperty
	 */
	public com.ibm.adtech.jastor.Thing addTax(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Removes a value for the 'tax' property.  This method should not
	 * be invoked while iterator through values.  In that case, the remove() method of the Iterator
	 * itself should be used.
	 * @param		The {@link com.ibm.adtech.jastor.Thing} to remove
	 * @see			#taxProperty
	 */
	public void removeTax(com.ibm.adtech.jastor.Thing tax) throws com.ibm.adtech.jastor.JastorException;
		
	/**
	 * Gets the 'currencyCode' property value
	 * @return		{@link java.lang.String}
	 * @see			#currencyCodeProperty
	 */
	public java.lang.String getCurrencyCode() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'currencyCode' property value
	 * @param		{@link java.lang.String}
	 * @see			#currencyCodeProperty
	 */
	public void setCurrencyCode(java.lang.String currencyCode) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'percent' property value
	 * @return		{@link java.lang.Float}
	 * @see			#percentProperty
	 */
	public java.lang.Float getPercent() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'percent' property value
	 * @param		{@link java.lang.Float}
	 * @see			#percentProperty
	 */
	public void setPercent(java.lang.Float percent) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'taxInclusive' property value
	 * @return		{@link java.lang.Boolean}
	 * @see			#taxInclusiveProperty
	 */
	public java.lang.Boolean getTaxInclusive() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'taxInclusive' property value
	 * @param		{@link java.lang.Boolean}
	 * @see			#taxInclusiveProperty
	 */
	public void setTaxInclusive(java.lang.Boolean taxInclusive) throws com.ibm.adtech.jastor.JastorException;

}