

package golfCourse.ontologies.jastor.price;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;


/**
 * Implementation of {@link golfCourse.ontologies.jastor.price.Price}
 * Use the golfCourse.ontologies.jastor.price.PriceFactory to create instances of this class.
 * <p>(URI: file:///D:/ontologies/domain/Golf/Price#Price)</p>
 * <br>
 */
public class PriceImpl extends com.ibm.adtech.jastor.ThingImpl implements golfCourse.ontologies.jastor.price.Price {
	

	private static com.hp.hpl.jena.rdf.model.Property amountProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#amount");
	private java.lang.Float amount;
	private static com.hp.hpl.jena.rdf.model.Property taxProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#tax");
	private java.util.ArrayList tax;
	private static com.hp.hpl.jena.rdf.model.Property currencyCodeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#currencyCode");
	private java.lang.String currencyCode;
	private static com.hp.hpl.jena.rdf.model.Property percentProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#percent");
	private java.lang.Float percent;
	private static com.hp.hpl.jena.rdf.model.Property taxInclusiveProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Price#taxInclusive");
	private java.lang.Boolean taxInclusive;

	PriceImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static PriceImpl getPrice(Resource resource, Model model) throws JastorException {
		if (!resource.hasProperty(RDF.type,Price.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + Price.TYPE);
		return new PriceImpl(resource, model);
	}
	    
	static PriceImpl createPrice(Resource resource, Model model) throws JastorException {
		PriceImpl impl = new PriceImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, Price.TYPE)))
			impl._model.add(impl._resource, RDF.type, Price.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	golfCourse.ontologies.jastor.price.PriceFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _resource.listProperties(amountProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(taxProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(currencyCodeProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(percentProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(taxInclusiveProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, golfCourse.ontologies.jastor.price.Price.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
		amount = null;
		tax = null;
		currencyCode = null;
		percent = null;
		taxInclusive = null;
	}

	public java.lang.Float getAmount() throws JastorException {
		if (amount != null)
			return amount;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, amountProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": amount getProperty() in golfCourse.ontologies.jastor.price.Price model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.Float))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal amount in Price is not of type java.lang.Float", literal);
		amount = (java.lang.Float)obj;
		return amount;
	}
	
	public void setAmount(java.lang.Float amount) throws JastorException {
		if (_resource.hasProperty(amountProperty)) {
			_resource.removeAll(amountProperty);
		}
		this.amount = amount;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (amount != null) {
			_resource.addProperty(amountProperty, _model.createTypedLiteral(amount));
		}	
	}


	private void initTax() throws JastorException {
		this.tax = new java.util.ArrayList();
		StmtIterator it = _model.listStatements(_resource, taxProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the file:///D:/ontologies/domain/Golf/Price#tax properties in Price model not a Resource", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
			if (true) { // don't check resource type if the property range is Resource
				com.ibm.adtech.jastor.Thing tax = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
				this.tax.add(tax);
			}
		}
	}

	public java.util.Iterator getTax() throws JastorException {
		if (tax == null)
			initTax();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(tax,_resource,taxProperty,true);
	}

	public void addTax(com.ibm.adtech.jastor.Thing tax) throws JastorException {
		if (this.tax == null)
			initTax();
		if (this.tax.contains(tax)) {
			this.tax.remove(tax);
			this.tax.add(tax);
			return;
		}
		this.tax.add(tax);
		_resource.addProperty(taxProperty,tax.resource());
	}
	
	public com.ibm.adtech.jastor.Thing addTax() throws JastorException {
		com.ibm.adtech.jastor.Thing tax = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		if (this.tax == null)
			initTax();
		this.tax.add(tax);
		_resource.addProperty(taxProperty,tax.resource());
		return tax;
	}
	
	public com.ibm.adtech.jastor.Thing addTax(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		com.ibm.adtech.jastor.Thing tax = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		if (this.tax == null)
			initTax();
		if (this.tax.contains(tax))
			return tax;
		this.tax.add(tax);
		_resource.addProperty(taxProperty,tax.resource());
		return tax;
	}
	
	public void removeTax(com.ibm.adtech.jastor.Thing tax) throws JastorException {
		if (this.tax == null)
			initTax();
		if (!this.tax.contains(tax))
			return;
		if (!_model.contains(_resource, taxProperty, tax.resource()))
			return;
		this.tax.remove(tax);
		_model.remove(_model.listStatements(_resource, taxProperty, tax.resource()));
	}
		 
	public java.lang.String getCurrencyCode() throws JastorException {
		if (currencyCode != null)
			return currencyCode;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, currencyCodeProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": currencyCode getProperty() in golfCourse.ontologies.jastor.price.Price model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal currencyCode in Price is not of type java.lang.String", literal);
		currencyCode = (java.lang.String)obj;
		return currencyCode;
	}
	
	public void setCurrencyCode(java.lang.String currencyCode) throws JastorException {
		if (_resource.hasProperty(currencyCodeProperty)) {
			_resource.removeAll(currencyCodeProperty);
		}
		this.currencyCode = currencyCode;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (currencyCode != null) {
			_resource.addProperty(currencyCodeProperty, _model.createTypedLiteral(currencyCode));
		}	
	}

	public java.lang.Float getPercent() throws JastorException {
		if (percent != null)
			return percent;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, percentProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": percent getProperty() in golfCourse.ontologies.jastor.price.Price model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.Float))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal percent in Price is not of type java.lang.Float", literal);
		percent = (java.lang.Float)obj;
		return percent;
	}
	
	public void setPercent(java.lang.Float percent) throws JastorException {
		if (_resource.hasProperty(percentProperty)) {
			_resource.removeAll(percentProperty);
		}
		this.percent = percent;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (percent != null) {
			_resource.addProperty(percentProperty, _model.createTypedLiteral(percent));
		}	
	}

	public java.lang.Boolean getTaxInclusive() throws JastorException {
		if (taxInclusive != null)
			return taxInclusive;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, taxInclusiveProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": taxInclusive getProperty() in golfCourse.ontologies.jastor.price.Price model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.Boolean))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal taxInclusive in Price is not of type java.lang.Boolean", literal);
		taxInclusive = (java.lang.Boolean)obj;
		return taxInclusive;
	}
	
	public void setTaxInclusive(java.lang.Boolean taxInclusive) throws JastorException {
		if (_resource.hasProperty(taxInclusiveProperty)) {
			_resource.removeAll(taxInclusiveProperty);
		}
		this.taxInclusive = taxInclusive;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (taxInclusive != null) {
			_resource.addProperty(taxInclusiveProperty, _model.createTypedLiteral(taxInclusive));
		}	
	}
 


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof PriceListener))
			throw new IllegalArgumentException("ThingListener must be instance of PriceListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((PriceListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof PriceListener))
			throw new IllegalArgumentException("ThingListener must be instance of PriceListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	// private class ThingModelChangedListener extends StatementListener {
	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(amountProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.Float)
					amount = (java.lang.Float) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						PriceListener listener=(PriceListener)iter.next();
						listener.amountChanged(golfCourse.ontologies.jastor.price.PriceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(taxProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _tax = null;
					try {
						_tax = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
					if (tax == null) {
						try {
							initTax();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!tax.contains(_tax))
						tax.add(_tax);
					if (listeners != null) {
						java.util.ArrayList consumersForTax;
						synchronized (listeners) {
							consumersForTax = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForTax.iterator();iter.hasNext();){
							PriceListener listener=(PriceListener)iter.next();
							listener.taxAdded(golfCourse.ontologies.jastor.price.PriceImpl.this,_tax);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(currencyCodeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					currencyCode = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						PriceListener listener=(PriceListener)iter.next();
						listener.currencyCodeChanged(golfCourse.ontologies.jastor.price.PriceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(percentProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.Float)
					percent = (java.lang.Float) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						PriceListener listener=(PriceListener)iter.next();
						listener.percentChanged(golfCourse.ontologies.jastor.price.PriceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(taxInclusiveProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.Boolean)
					taxInclusive = (java.lang.Boolean) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						PriceListener listener=(PriceListener)iter.next();
						listener.taxInclusiveChanged(golfCourse.ontologies.jastor.price.PriceImpl.this);
					}
				}
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(amountProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.Float)
					if (amount != null && amount.equals(obj))
						amount = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						PriceListener listener=(PriceListener)iter.next();
						listener.amountChanged(golfCourse.ontologies.jastor.price.PriceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(taxProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _tax = null;
					if (tax != null) {
						boolean found = false;
						for (int i=0;i<tax.size();i++) {
							com.ibm.adtech.jastor.Thing __item = (com.ibm.adtech.jastor.Thing) tax.get(i);
							if (__item.resource().equals(resource)) {
								found = true;
								_tax = __item;
								break;
							}
						}
						if (found)
							tax.remove(_tax);
						else {
							try {
								_tax = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
							} catch (JastorException e) {
							}
						}
					} else {
						try {
							_tax = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
						} catch (JastorException e) {
						}
					}
					if (listeners != null) {
						java.util.ArrayList consumersForTax;
						synchronized (listeners) {
							consumersForTax = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForTax.iterator();iter.hasNext();){
							PriceListener listener=(PriceListener)iter.next();
							listener.taxRemoved(golfCourse.ontologies.jastor.price.PriceImpl.this,_tax);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(currencyCodeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (currencyCode != null && currencyCode.equals(obj))
						currencyCode = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						PriceListener listener=(PriceListener)iter.next();
						listener.currencyCodeChanged(golfCourse.ontologies.jastor.price.PriceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(percentProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.Float)
					if (percent != null && percent.equals(obj))
						percent = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						PriceListener listener=(PriceListener)iter.next();
						listener.percentChanged(golfCourse.ontologies.jastor.price.PriceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(taxInclusiveProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.Boolean)
					if (taxInclusive != null && taxInclusive.equals(obj))
						taxInclusive = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						PriceListener listener=(PriceListener)iter.next();
						listener.taxInclusiveChanged(golfCourse.ontologies.jastor.price.PriceImpl.this);
					}
				}
				return;
			}
		}

	//}
	


}