package golfCourse.translations.fromOTA;

import golfCourse.ontologies.jastor.location.AddressRecord;
import golfCourse.ontologies.jastor.location.AddressRecordFactory;
import golfCourse.properties.GolfCourseSystemProperties;
import golfCourse.translations.castor.Address;

import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.rdf.model.Resource;
import com.ibm.adtech.jastor.JastorException;

public class AddressTranslator {
	
	private OntModel model;
	
	public AddressTranslator(OntModel model)
	{
		this.model = model;
	}
	
	public AddressRecord translate(Address otaAddress, String golfCourseID) throws JastorException
	{
		if(model == null)
			return null;
		
		if(otaAddress == null)
			return null;
	
		Resource r = model.createResource(AddressRecord.TYPE.getNameSpace() + golfCourseID + "_address");
		AddressRecord addressRecord = AddressRecordFactory.createAddressRecord(r, model);
		
		addressRecord.setCity(otaAddress.getCityName());
		
		if(otaAddress.getCountryName() != null)
			addressRecord.setCountry(otaAddress.getCountryName().getContent());
		
		if(otaAddress.getAddressLineCount() > 0)
			addressRecord.setFullAddress(otaAddress.getAddressLine(0));
		
		if(otaAddress.getStreetNmbr() != null)
			addressRecord.setStreet(otaAddress.getStreetNmbr().getContent());
		addressRecord.setZip(otaAddress.getPostalCode());
		
		return addressRecord;
	}

}
