package golfCourse.translations.toOTA;

import golfCourse.exceptions.TranslateException;
import golfCourse.translations.castor.Errors;
import golfCourse.translations.castor.OTA_GolfCourseSearchRS;

import java.io.StringWriter;
import java.io.Writer;
import java.math.BigDecimal;

import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;

public class GolfCourseSearchRSErrorTranslator {

    public static String generateError(String desc) throws TranslateException
    {
            OTA_GolfCourseSearchRS answer = generate(desc);

            Writer out = new StringWriter();

            try {
                    answer.marshal(out);
            }
            catch(MarshalException e)
            {
                    throw new TranslateException("Marshal: " + e);
            }
            catch(ValidationException e2)
            {
                    throw new TranslateException("Validation: " + e2);
            }
            return out.toString();
    }

    private static OTA_GolfCourseSearchRS generate(String desc)
    {
            OTA_GolfCourseSearchRS ota = new OTA_GolfCourseSearchRS();

            ota.setVersion(BigDecimal.valueOf(23));

            Errors errors = ErrorsRSTranslator.generateErrors(desc);

            ota.setErrors(errors);
            return ota;
    }
}
