package golfCourse.translations.toOTA;

import java.io.StringWriter;
import java.io.Writer;

import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;

import golfCourse.exceptions.TranslateException;
import golfCourse.ontologies.jastor.location.AddressRecord;
import golfCourse.translations.castor.CountryName;

import com.ibm.adtech.jastor.JastorException;

/**
 * Translation address ontology to ota
 */
public class OTAAddressTranslator {

	public static golfCourse.translations.castor.Address translateToOTA(AddressRecord address) throws TranslateException
	{
		golfCourse.translations.castor.Address otaAddress = new golfCourse.translations.castor.Address();
		try {
			otaAddress.setCityName(address.getCity());
			CountryName countryName = new CountryName();
			countryName.setContent(address.getCountry());
			//countryName.setCode();
			otaAddress.setCountryName(countryName);
			otaAddress.setCounty(address.getCountry());
			//otaAddress.setPostalCode();
			//otaAddress.setStreetNmbr();
			otaAddress.setAddressLine(new String[]{ address.getFullAddress()});
			
		//	address.getFlatNumber();
		//	address.getFullAddress();
		//	address.getHouseNumber();
		//	address.getRegion();
		//	address.getStreet();
		//	address.getZip();
		} catch(JastorException e)
		{
			throw new TranslateException("jastor: " + e);
		}
		
		try {
			otaAddress.validate();
		} catch(ValidationException e)
		{
			throw new TranslateException("Validation exception " + e);
		}
		return otaAddress;
	}
	
	public static String translateToOTAString(AddressRecord address) throws TranslateException
	{
		golfCourse.translations.castor.Address otaAddress = translateToOTA(address);
		
		Writer writer = new StringWriter();
		try {
			otaAddress.marshal(writer);
		}
		catch(MarshalException e)
		{
			throw new TranslateException("Marshal exception " + e);
		}
		catch(ValidationException e2)
		{
			throw new TranslateException("Validation exception " + e2);
		}	
		
		return writer.toString();
	}
}
